package ch.lantersoft.grd;

import java.awt.Color;
import java.util.Observable;

public class Fraction extends Observable implements Comparable<Fraction> {

	public final static int MAX_FRAC = 100;
	
	private boolean active; // true, if not deleted
	private boolean enabled; // true, if should be considered while crating the gradient
	private boolean selected; // true, if selected
	private float fraction;
	private int red;
	private int green;
	private int blue;
	
	public Fraction() {
		this(1f,Color.BLACK);
	}
	
	public Fraction(float fraction, Color color) {
		this.active = true;
		this.enabled = true;
		this.fraction = fraction;
		this.red = color.getRed();
		this.green = color.getGreen();
		this.blue = color.getBlue();
	}
	
	public Fraction(float fraction, int red, int green, int blue) {
		this.active = true;
		this.enabled = true;
		this.fraction = fraction;
		this.red = red;
		this.green = green;
		this.blue = blue;
	}
	
	public float getFraction() {
		return fraction;
	}
	
	public void setFraction(float fraction) {
		this.fraction = Math.round(fraction*MAX_FRAC)/(float)MAX_FRAC;
		fireStateChanged();
	}
	
	public int getRed() {
		return red;
	}
	
	public void setRed(int red) {
		this.red = red;
		fireStateChanged();
	}
	
	public int getGreen() {
		return green;
	}
	
	public void setGreen(int green) {
		this.green = green;
		fireStateChanged();
	}
	
	public int getBlue() {
		return blue;
	}
	
	public void setBlue(int blue) {
		this.blue = blue;
		fireStateChanged();
	}
	
	public Color getColor() {
		return new Color(red,green,blue);
	}

	public boolean isEnabled() {
		return enabled;
	}

	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
		fireStateChanged();
	}

	public boolean isSelected() {
		return selected;
	}

	public void setSelected(boolean selected) {
		this.selected = selected;
		fireStateChanged();
	}

	public boolean isActive() {
		return active;
	}

	public void setActive(boolean active) {
		this.active = active;
		fireStateChanged();
	}
	
	private void fireStateChanged() {
		setChanged();
		notifyObservers();
	}

	@Override
	public int compareTo(Fraction o) {
		return Math.round(fraction-o.fraction);
	}
}
