package ch.lantersoft.grd.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;

import ch.lantersoft.grd.protector.Protector;

public class CmpCode extends JComponent {

	public CmpCode(final Protector protector) {
		setLayout(new BorderLayout());
		
		final JTextArea txa = new JTextArea(protector.getCode());
		txa.setBorder(new EmptyBorder(0,5,0,5));
		txa.setFont(new Font("Courier New",Font.PLAIN,11));
		txa.setEditable(false);
		
		final JScrollPane scr = new JScrollPane(txa,JScrollPane.VERTICAL_SCROLLBAR_NEVER,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED) {
			@Override
			public Dimension getPreferredSize() {
				Dimension dim = super.getPreferredSize();
				return new Dimension(dim.width,dim.height+getHorizontalScrollBar().getHeight());
			}
		};
		add(scr);

		protector.addObserver(new Observer() {
			public void update(Observable o, Object arg) {
				txa.setText(protector.getCode());
			}
		});
	}
	
}
