package ch.lantersoft.grd.ui;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import ch.lantersoft.grd.protector.LinearGradientProtector;
import ch.lantersoft.grd.protector.Protector;
import ch.lantersoft.grd.protector.RadialGradientProtector;


public class CmpCtrl extends JComponent {

	private static final long serialVersionUID = 201008311116L;

	public CmpCtrl(final Protector protector) {
		setLayout(new BorderLayout());
		setBorder(new EmptyBorder(5,5,0,5));
		
		final JComboBox cbo = new JComboBox(protector.getPaintNames());
		
		final CardLayout cl = new CardLayout();
		final JPanel pnlctrls = new JPanel(cl);
		
		final String[] names = protector.getPaintNames();
		
		final LinearGradientProtector lgp = protector.getLinearGradientProtector();
		final RadialGradientProtector rgp = protector.getRadialGradientProtector();
		
		final CtrlLinearGradient clg = new CtrlLinearGradient(lgp);
		final CtrlRadialGradient rlg = new CtrlRadialGradient(rgp); 

		pnlctrls.add(clg,names[0]);
		pnlctrls.add(rlg,names[1]);
		
		add(cbo,BorderLayout.NORTH);
		add(pnlctrls,BorderLayout.CENTER);
		
		cbo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				protector.setSelection(cbo.getSelectedIndex());
			}
		});
		
		protector.addObserver(new Observer() {
			public void update(Observable o, Object arg) {
				cl.show(pnlctrls, names[protector.getSelection()]);
			}
		});
	}
	
}
