package ch.lantersoft.grd.ui;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import ch.lantersoft.grd.Fraction;
import ch.lantersoft.grd.protector.MultipleGradientProtector;

public class CmpFractionContainer extends JComponent {

	private MultipleGradientProtector lgprotector;
	private JPanel pnlFractions;
	
	public CmpFractionContainer(MultipleGradientProtector mgp) {
		this.lgprotector = mgp;
		setLayout(new BorderLayout());

		pnlFractions = new JPanel();
		pnlFractions.setLayout(new BoxLayout(pnlFractions, BoxLayout.Y_AXIS));
		for (Fraction f:mgp.getFractions()) {
			addFraction(f);
		}
		
		JPanel pnlButtons = new JPanel(new GridLayout(1,2));
		JButton btnAdd = new JButton("Add");
		JButton btnRem = new JButton("Remove");
		
		pnlButtons.add(btnAdd);
		pnlButtons.add(btnRem);
		
		JScrollPane scrFractions = new JScrollPane(pnlFractions,
			JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
			JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		
		add(scrFractions,BorderLayout.CENTER);
		add(pnlButtons,BorderLayout.SOUTH);
		
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				createNewFraction();
			}
		});
		
		btnRem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeFractions();
			}
		});
	}
	
	private void createNewFraction() {
		Fraction fraction = new Fraction();
		lgprotector.addFraction(fraction);
		addFraction(fraction);
	}
	
	private void addFraction(final Fraction fraction) {
		final CmpGradientFraction cgf = new CmpGradientFraction(fraction);
		cgf.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (fraction.isSelected()) {
					lgprotector.removeSelection(fraction);
				} else {
					if ((e.getModifiers() & ActionEvent.SHIFT_MASK) != 0) { // shift pressed
						lgprotector.addSelection(fraction);
					} else {
						lgprotector.setSelection(fraction);
					}
				}
			}
		});
		pnlFractions.add(cgf);
		pnlFractions.revalidate();
	}
	
	private void removeFractions() {
		lgprotector.removeSelectedFractions();
		pnlFractions.revalidate();
		pnlFractions.repaint();
	}
	
}
