package ch.lantersoft.grd.ui;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JComponent;
import javax.swing.border.BevelBorder;

import ch.lantersoft.grd.protector.Protector;


public class CmpGradient extends JComponent implements Observer {

	private static final long serialVersionUID = 201008301837L;
	
	private Protector protector;
	
	public CmpGradient(final Protector protector) {
		this.protector = protector;
		setBorder(new BevelBorder(BevelBorder.LOWERED)); // new EtchedBorder(EtchedBorder.RAISED));
		setPreferredSize(new Dimension(protector.getWidth(),protector.getHeight()));
		
		addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				protector.setSize(getWidth(), getHeight());
			}
		});
		
		protector.addObserver(new Observer() {
			public void update(Observable o, Object arg) {
				repaint();
			}
		});
		
		addMouseMotionListener(new MouseMotionListener() {
			public void mouseMoved(MouseEvent e) {
				protector.move(e.getX(), e.getY());
			}
			
			public void mouseDragged(MouseEvent e) {
				protector.move(e.getX(), e.getY());
			}
		});
		
		addMouseListener(new MouseAdapter() {
			public void mouseReleased(MouseEvent e) {
				protector.click(e.getX(), e.getY());
			}
		});
	}
	
	@Override
	public void paintComponent(Graphics g) {
		Paint gp = protector.getPaint();
		Graphics2D g2 = (Graphics2D) g.create();
		g2.setPaint(gp);
		g2.fillRect(0,0,getWidth(),getHeight());
	}

	@Override
	public void update(Observable o, Object arg) {
		repaint();
	}
}
