package ch.lantersoft.grd.ui.util;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JComponent;

public class GridBagLayoutComponent extends JComponent {

	private static final long serialVersionUID = 201007231517L;
	
	// Layout of this panel
	private GridBagLayout gbl;
	
	// Constraints of the Layout
	private GridBagConstraints gbc;
	
	public GridBagLayoutComponent() {
		gbl = new GridBagLayout();
		gbc = new GridBagConstraints();
		setLayout(gbl);
	}
	
	/**
	 * Add a component with the given parameters to the panel
	 */
	public void addComponent(Component c,
			int x, int y, int width, int height, double weightx, double weighty) {
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.weightx = weightx;
		gbc.weighty = weighty;
		gbl.setConstraints(c, gbc);
		this.add(c);
	}
	
	/**
	 * Return the layout of this panel
	 * @return the layout
	 */
	public GridBagLayout getGridBagLayout() {
		return gbl;
	}
	
	/**
	 * Return the constraints of the layout
	 * @return the constraints
	 */
	public GridBagConstraints getGridBagConstraints() {
		return gbc;
	}
	
}
